#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <mqueue.h>

void errExit(const char *message)
{
	perror(message);
	exit(EXIT_FAILURE);
}

int main()
{
	ssize_t taille_lue = 0, taille_ecrite = 0, retour_write = 0;
	const size_t buffer_size = 2048;
	char buffer[buffer_size];
	char prio_buffer[256];
	mqd_t file_message;
	unsigned int priorite;
	int ret = 0;
	
	printf("Ouverture de la file de message...\n");
	file_message = mq_open("/filemessage", O_RDONLY);
	if (file_message == (mqd_t) -1) {
		errExit("Erreur lors de l'ouverture de la file de message");
	}
	printf("File de message ouverte avec succès.\n");

	printf("Lecture des données depuis la file de message :\n");
	while (1) {
		taille_lue = mq_receive(file_message, buffer, buffer_size, &priorite);
		if (taille_lue == -1) {
			errExit("Erreur lors de la lecture dans la file de message");
		} else if (taille_lue == 0) {
			break;
		} else {
			ret = snprintf(prio_buffer, 256, "Priorité %d: ", priorite);
			if (ret >= 256) {
				errExit("snprintf");
			}
			taille_ecrite = 0;
			while (taille_ecrite < ret) {
				retour_write = write(STDOUT_FILENO, prio_buffer + taille_ecrite, ret - taille_ecrite);
				if (retour_write == -1) {
					errExit("Erreur lors de l'écriture sur la sortie standard");
				}
				taille_ecrite += retour_write;
			}
			taille_ecrite = 0;
			while (taille_ecrite < taille_lue) {
				retour_write = write(STDOUT_FILENO, buffer + taille_ecrite, taille_lue - taille_ecrite);
				if (retour_write == -1) {
					errExit("Erreur lors de l'écriture sur la sortie standard");
				}
				taille_ecrite += retour_write;
			}
		}
	}
	printf("Fin de la lecture.\n");

	return EXIT_SUCCESS;
}
