#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

void errExit(const char *message)
{
	perror(message);
	exit(EXIT_FAILURE);
}

int main()
{
	int tube = 0;
	ssize_t taille_lue = 0, taille_ecrite = 0, retour_write = 0;
	const size_t buffer_size = 256;
	char buffer[buffer_size];
	
	printf("Ouverture du tube en lecture...\n");
	tube = open("montube", O_RDONLY);
	if (tube == -1) {
		errExit("Erreur lors de l'ouverture du tube");
	}
	printf("Tube ouvert avec succès.\n");

	printf("Lecture des données depuis le tube :\n");
	while (1) {
		taille_lue = read(tube, buffer, buffer_size);
		if (taille_lue == -1) {
			errExit("Erreur lors de la lecture de la sortie du tube");
		} else if (taille_lue == 0) {
			break;
		} else {
			taille_ecrite = 0;
			while (taille_ecrite < taille_lue) {
				retour_write = write(STDOUT_FILENO, buffer + taille_ecrite, taille_lue - taille_ecrite);
				if (retour_write == -1) {
					errExit("Erreur lors de l'écriture sur la sortie standard");
				}
				taille_ecrite += retour_write;
			}
		}
	}
	printf("Fin de la lecture.\n");

	return EXIT_SUCCESS;
}
